
(define
	(domain depots)
	(:requirements
		:strips :typing
	)
	(:types
		place locatable - object
		depot distributor - place
		truck hoist surface - locatable
		pallet crate - surface
	)
	(:predicates
		(at ?x - locatable ?y - place)
		(on ?x - crate ?y - surface)
		(in ?x - crate ?y - truck)
		(lifting ?x - hoist ?y - crate)
		(available ?x - hoist)
		(clear ?x - surface)
	)
	(:action drive
		:parameters (?x - truck ?y ?z - place)
		:precondition
			(and (at ?x ?y))
		:effect
			(and
				(not (at ?x ?y))
				(at ?x ?z)
			)
	)
	(:action lift
		:parameters (?x - hoist ?y - crate ?z - surface ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(available ?x)
				(at ?y ?p)
				(on ?y ?z)
				(clear ?y)
			)
		:effect
			(and
				(not (at ?y ?p))
				(lifting ?x ?y)
				(not (clear ?y))
				(not (available ?x))
				(clear ?z)
				(not (on ?y ?z))
			)
	)
	(:action drop
		:parameters (?x - hoist ?y - crate ?z - surface ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(clear ?z)
				(lifting ?x ?y)
			)
		:effect
			(and
				(available ?x)
				(not (lifting ?x ?y))
				(at ?y ?p)
				(not (clear ?z))
				(clear ?y)
				(on ?y ?z)
			)
	)
	(:action load
		:parameters (?x - hoist ?y - crate ?z - truck ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(lifting ?x ?y)
			)
		:effect
			(and
				(not (lifting ?x ?y))
				(in ?y ?z)
				(available ?x)
			)
	)
	(:action unload
		:parameters (?x - hoist ?y - crate ?z - truck ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(available ?x)
				(in ?y ?z)
			)
		:effect
			(and
				(not (in ?y ?z))
				(not (available ?x))
				(lifting ?x ?y)
			)
	)
;|	(:macro
		(:action chunk-26-0
			:parameters (?hoist3 - hoist ?crate3 - crate ?pallet3 - pallet ?distributor1 - distributor
				?crate4 - crate ?truck0 - truck)
			:precondition
				(and
					(at ?hoist3 ?distributor1)
					(at ?pallet3 ?distributor1)
					(clear ?pallet3)
					(lifting ?hoist3 ?crate3)
					(in ?crate3 ?truck0)
					(at ?truck0 ?distributor1)
					(in ?crate4 ?truck0)
				)
			:effect
				(and
					(at ?crate3 ?distributor1)
					(not (clear ?pallet3))
					(on ?crate3 ?pallet3)
					(not (in ?crate4 ?truck0))
					(at ?crate4 ?distributor1)
					(clear ?crate4)
					(on ?crate4 ?crate3)
					(not (in ?crate3 ?truck0))
				)
;|			:permutation
;|				(drop ?hoist3 ?crate3 ?pallet3 ?distributor1)
;|				(unload ?hoist3 ?crate4 ?truck0 ?distributor1)
;|				(drop ?hoist3 ?crate4 ?crate3 ?distributor1)
;|				(unload ?hoist3 ?crate3 ?truck0 ?distributor1)
		)
;|	)
;|	(:macro
		(:action chunk-30-3
			:parameters (?hoist4 - hoist ?crate5 - crate ?truck0 - truck ?distributor1 - distributor
				?truck1 - truck)
			:precondition
				(and
					(at ?hoist4 ?distributor1)
					(at ?truck0 ?distributor1)
					(available ?hoist4)
					(in ?crate5 ?truck0)
					(at ?truck1 ?distributor1)
				)
			:effect
				(and
					(not (in ?crate5 ?truck0))
					(in ?crate5 ?truck1)
				)
;|			:permutation
;|				(unload ?hoist4 ?crate5 ?truck0 ?distributor1)
;|				(load ?hoist4 ?crate5 ?truck1 ?distributor1)
		)
;|	)
;|	(:macro
		(:action chunk-11-0
			:parameters (?hoist3 - hoist ?crate3 - crate ?truck0 - truck ?distributor0 - distributor
				?pallet3 - pallet)
			:precondition
				(and
					(at ?hoist3 ?distributor0)
					(at ?truck0 ?distributor0)
					(available ?hoist3)
					(in ?crate3 ?truck0)
					(clear ?pallet3)
					(at ?pallet3 ?distributor0)
				)
			:effect
				(and
					(not (in ?crate3 ?truck0))
					(at ?crate3 ?distributor0)
					(not (clear ?pallet3))
					(clear ?crate3)
					(on ?crate3 ?pallet3)
				)
;|			:permutation
;|				(unload ?hoist3 ?crate3 ?truck0 ?distributor0)
;|				(drop ?hoist3 ?crate3 ?pallet3 ?distributor0)
		)
;|	)
;|	(:macro
		(:action chunk-27-4
			:parameters (?truck1 - truck ?distributor1 - distributor ?depot0 - depot ?hoist0 - hoist
				?crate2 - crate ?depot2 - depot)
			:precondition
				(and
					(at ?truck1 ?distributor1)
					(at ?hoist0 ?depot0)
					(available ?hoist0)
					(in ?crate2 ?truck1)
				)
			:effect
				(and
					(not (at ?truck1 ?distributor1))
					(not (in ?crate2 ?truck1))
					(not (available ?hoist0))
					(lifting ?hoist0 ?crate2)
					(at ?truck1 ?depot2)
				)
;|			:permutation
;|				(drive ?truck1 ?distributor1 ?depot0)
;|				(unload ?hoist0 ?crate2 ?truck1 ?depot0)
;|				(drive ?truck1 ?depot0 ?distributor1)
;|				(drive ?truck1 ?distributor1 ?depot2)
		)
;|	)
;|	(:macro
		(:action chunk-14-4
			:parameters (?hoist4 - hoist ?crate5 - crate ?truck0 - truck ?distributor1 - distributor
				?crate4 - crate)
			:precondition
				(and
					(at ?hoist4 ?distributor1)
					(at ?truck0 ?distributor1)
					(available ?hoist4)
					(in ?crate5 ?truck0)
					(clear ?crate4)
					(at ?crate4 ?distributor1)
				)
			:effect
				(and
					(not (in ?crate5 ?truck0))
					(at ?crate5 ?distributor1)
					(not (clear ?crate4))
					(clear ?crate5)
					(on ?crate5 ?crate4)
				)
;|			:permutation
;|				(unload ?hoist4 ?crate5 ?truck0 ?distributor1)
;|				(drop ?hoist4 ?crate5 ?crate4 ?distributor1)
		)
;|	)
;|	(:macro
		(:action chunk-35-5
			:parameters (?truck1 - truck ?depot2 - depot ?distributor1 - distributor ?depot0
				?depot1 - depot)
			:precondition
				(and (at ?truck1 ?depot2))
			:effect
				(and
					(not (at ?truck1 ?depot2))
					(at ?truck1 ?depot1)
				)
;|			:permutation
;|				(drive ?truck1 ?depot2 ?distributor1)
;|				(drive ?truck1 ?distributor1 ?depot0)
;|				(drive ?truck1 ?depot0 ?depot1)
		)
;|	)
)

