
(define
	(domain depots)
	(:requirements
		:strips :typing
	)
	(:types
		place locatable - object
		depot distributor - place
		truck hoist surface - locatable
		pallet crate - surface
	)
	(:predicates
		(at ?x - locatable ?y - place)
		(on ?x - crate ?y - surface)
		(in ?x - crate ?y - truck)
		(lifting ?x - hoist ?y - crate)
		(available ?x - hoist)
		(clear ?x - surface)
	)
	(:action drive
		:parameters (?x - truck ?y ?z - place)
		:precondition
			(and (at ?x ?y))
		:effect
			(and
				(not (at ?x ?y))
				(at ?x ?z)
			)
	)
	(:action lift
		:parameters (?x - hoist ?y - crate ?z - surface ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(available ?x)
				(at ?y ?p)
				(on ?y ?z)
				(clear ?y)
			)
		:effect
			(and
				(not (at ?y ?p))
				(lifting ?x ?y)
				(not (clear ?y))
				(not (available ?x))
				(clear ?z)
				(not (on ?y ?z))
			)
	)
	(:action drop
		:parameters (?x - hoist ?y - crate ?z - surface ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(clear ?z)
				(lifting ?x ?y)
			)
		:effect
			(and
				(available ?x)
				(not (lifting ?x ?y))
				(at ?y ?p)
				(not (clear ?z))
				(clear ?y)
				(on ?y ?z)
			)
	)
	(:action load
		:parameters (?x - hoist ?y - crate ?z - truck ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(lifting ?x ?y)
			)
		:effect
			(and
				(not (lifting ?x ?y))
				(in ?y ?z)
				(available ?x)
			)
	)
	(:action unload
		:parameters (?x - hoist ?y - crate ?z - truck ?p - place)
		:precondition
			(and
				(at ?x ?p)
				(at ?z ?p)
				(available ?x)
				(in ?y ?z)
			)
		:effect
			(and
				(not (in ?y ?z))
				(not (available ?x))
				(lifting ?x ?y)
			)
	)
;|	(:macro
		(:action chunk-7-1
			:parameters (?truck0 - truck ?distributor0 ?distributor1 - distributor ?hoist3 - hoist
				?crate8 - crate ?pallet3 - pallet)
			:precondition
				(and
					(at ?truck0 ?distributor0)
					(at ?hoist3 ?distributor1)
					(available ?hoist3)
					(in ?crate8 ?truck0)
					(clear ?pallet3)
					(at ?pallet3 ?distributor1)
				)
			:effect
				(and
					(not (in ?crate8 ?truck0))
					(at ?crate8 ?distributor1)
					(not (clear ?pallet3))
					(clear ?crate8)
					(on ?crate8 ?pallet3)
				)
;|			:permutation
;|				(drive ?truck0 ?distributor0 ?distributor1)
;|				(unload ?hoist3 ?crate8 ?truck0 ?distributor1)
;|				(drive ?truck0 ?distributor1 ?distributor0)
;|				(drop ?hoist3 ?crate8 ?pallet3 ?distributor1)
		)
;|	)
;|	(:macro
		(:action chunk-14-1
			:parameters (?truck0 - truck ?depot1 ?depot0 - depot ?hoist0 - hoist
				?crate2 - crate ?distributor0 - distributor)
			:precondition
				(and
					(at ?truck0 ?depot1)
					(at ?hoist0 ?depot0)
					(lifting ?hoist0 ?crate2)
				)
			:effect
				(and
					(not (at ?truck0 ?depot1))
					(not (lifting ?hoist0 ?crate2))
					(in ?crate2 ?truck0)
					(available ?hoist0)
					(at ?truck0 ?distributor0)
				)
;|			:permutation
;|				(drive ?truck0 ?depot1 ?depot0)
;|				(load ?hoist0 ?crate2 ?truck0 ?depot0)
;|				(drive ?truck0 ?depot0 ?distributor0)
		)
;|	)
;|	(:macro
		(:action chunk-31-4
			:parameters (?truck0 - truck ?depot0 - depot ?distributor0 - distributor ?hoist2 - hoist
				?crate3 - crate ?distributor1 - distributor)
			:precondition
				(and
					(at ?truck0 ?depot0)
					(at ?hoist2 ?distributor0)
					(lifting ?hoist2 ?crate3)
				)
			:effect
				(and
					(not (at ?truck0 ?depot0))
					(not (lifting ?hoist2 ?crate3))
					(in ?crate3 ?truck0)
					(available ?hoist2)
					(at ?truck0 ?distributor1)
				)
;|			:permutation
;|				(drive ?truck0 ?depot0 ?distributor0)
;|				(load ?hoist2 ?crate3 ?truck0 ?distributor0)
;|				(drive ?truck0 ?distributor0 ?depot0)
;|				(drive ?truck0 ?depot0 ?distributor1)
		)
;|	)
)

