
(define
	(domain parking)
	(:requirements
		:strips :typing
	)
	(:types
		car curb
	)
	(:predicates
		(at-curb ?car - car)
		(at-curb-num ?car - car ?curb - curb)
		(behind-car ?car ?front-car - car)
		(car-clear ?car - car)
		(curb-clear ?curb - curb)
	)
	(:action move-curb-to-curb
		:parameters (?car - car ?curbsrc ?curbdest - curb)
		:precondition
			(and
				(car-clear ?car)
				(curb-clear ?curbdest)
				(at-curb-num ?car ?curbsrc)
			)
		:effect
			(and
				(not (curb-clear ?curbdest))
				(curb-clear ?curbsrc)
				(at-curb-num ?car ?curbdest)
				(not (at-curb-num ?car ?curbsrc))
			)
	)
	(:action move-curb-to-car
		:parameters (?car - car ?curbsrc - curb ?cardest - car)
		:precondition
			(and
				(car-clear ?car)
				(car-clear ?cardest)
				(at-curb-num ?car ?curbsrc)
				(at-curb ?cardest)
			)
		:effect
			(and
				(not (car-clear ?cardest))
				(curb-clear ?curbsrc)
				(behind-car ?car ?cardest)
				(not (at-curb-num ?car ?curbsrc))
				(not (at-curb ?car))
			)
	)
	(:action move-car-to-curb
		:parameters (?car ?carsrc - car ?curbdest - curb)
		:precondition
			(and
				(car-clear ?car)
				(curb-clear ?curbdest)
				(behind-car ?car ?carsrc)
			)
		:effect
			(and
				(not (curb-clear ?curbdest))
				(car-clear ?carsrc)
				(at-curb-num ?car ?curbdest)
				(not (behind-car ?car ?carsrc))
				(at-curb ?car)
			)
	)
	(:action move-car-to-car
		:parameters (?car ?carsrc ?cardest - car)
		:precondition
			(and
				(car-clear ?car)
				(car-clear ?cardest)
				(behind-car ?car ?carsrc)
				(at-curb ?cardest)
			)
		:effect
			(and
				(not (car-clear ?cardest))
				(car-clear ?carsrc)
				(behind-car ?car ?cardest)
				(not (behind-car ?car ?carsrc))
			)
	)
;|	(:macro
		(:action chunk-1-1-17
			:parameters (?car_3 ?car_1 - car ?curb_3 ?curb_0 - curb)
			:precondition
				(and
					(car-clear ?car_3)
					(curb-clear ?curb_3)
					(behind-car ?car_3 ?car_1)
					(at-curb-num ?car_1 ?curb_0)
				)
			:effect
				(and
					(not (curb-clear ?curb_3))
					(car-clear ?car_1)
					(at-curb-num ?car_3 ?curb_3)
					(not (behind-car ?car_3 ?car_1))
					(at-curb ?car_3)
					(not (car-clear ?car_3))
					(curb-clear ?curb_0)
					(behind-car ?car_1 ?car_3)
					(not (at-curb-num ?car_1 ?curb_0))
					(not (at-curb ?car_1))
				)
;|			:permutation
;|				(move-car-to-curb ?car_3 ?car_1 ?curb_3)
;|				(move-curb-to-car ?car_1 ?curb_0 ?car_3)
		)
;|	)
)

